[package]
name = "upend-cli"
authors = ["Tomáš Mládek <t@mldk.cz>"]
version = "0.1.0"
edition = "2021"

[dependencies]
upend = { path = "../" }
clap = { version = "4.2.4", features = ["derive", "env", "color"] }

log = "0.4"
tracing = "0.1"
tracing-subscriber = { version = "0.3", features = ["env-filter"] }

anyhow = "1.0"
thiserror = "1.0"

rayon = "1.4.0"
num_cpus = "1.13"
futures = "0.3.24"
futures-util = "~0.3.12"
lazy_static = "1.4.0"
once_cell = "1.7.2"
lru = "0.7.0"

diesel = { version = "1.4", features = [
    "sqlite",
    "r2d2",
    "chrono",
    "serde_json",
] }
diesel_migrations = "1.4"
libsqlite3-sys = { version = "^0", features = ["bundled"] }

actix = "0.13"
actix-files = "0.6"
actix-rt = "2"
actix-web = "4"
actix_derive = "0.6"
actix-cors = "0.6"
actix-multipart = "0.6.0"
jsonwebtoken = "8"

chrono = { version = "0.4", features = ["serde"] }
serde = { version = "1.0", features = ["derive"] }
serde_json = "1.0"
lexpr = "0.2.6"
regex = "1"

multibase = "0.9"
multihash = { version = "*", default-features = false, features = [
    "alloc",
    "multihash-impl",
    "sha2",
    "identity",
] }
uuid = { version = "0.8", features = ["v4"] }

filebuffer = "0.4.0"
tempfile = "^3.2.0"
walkdir = "2"

rand = "0.8"

mime = "^0.3.16"
tree_magic_mini = "3.0.2"

opener = { version = "^0.5.0", optional = true }
is_executable = { version = "1.0.1", optional = true }
webbrowser = { version = "^0.5.5", optional = true }

nonempty = "0.6.0"

image = { version = "0.23.14", optional = true }
webp = { version = "0.2.0", optional = true }

webpage = { version = "1.5.0", optional = true, default-features = false}
id3 = { version = "1.0.2", optional = true }
kamadak-exif = { version = "0.5.4", optional = true }

shadow-rs = "0.17"
reqwest = { version = "0.11.16", features = ["blocking", "json"] }
url = "2"

bytes = "1.4.0"

[build-dependencies]
shadow-rs = "0.17"

[features]
default = ["desktop", "previews", "previews-image", "extractors-web", "extractors-audio", "extractors-photo", "extractors-media"]
desktop = ["webbrowser", "opener", "is_executable"]
previews = []
previews-image = ["image", "webp", "kamadak-exif"]
extractors-web = ["webpage"]
extractors-audio = ["id3"]
extractors-photo = ["kamadak-exif"]
extractors-media = []
